import threading
import mainWindow
import gtk
import common
import numarray as na
import time
import struct
import socket
import copy

def flip(arr):
    r, c = arr.shape
    inv1 = -na.arange(r)-1
    inv2 = -na.arange(c)-1
    res = na.take(arr, inv2, axis = 1)
    return na.take(res, inv1, axis = 0)

class sMessage:
    def __init__(self):
    	self.typ = 0
	self.length = 0
	self.data = ''
    

class socketThread(threading.Thread):
    def __init__(self, name='TestThread'):
        """ constructor, setting initial variables """
        self._stopevent = threading.Event()
        self._sleepperiod = 0.4
        threading.Thread.__init__(self, name=name)
	self.smessage = sMessage()
        self.host = common.host
        self.port = common.port
        print "self.host = ", self.host
        print "self.port = ", self.port

    def initSocket(self):
        self.sock = None
        self.host = common.host
        self.port = common.port        
        for res in socket.getaddrinfo(self.host, self.port, socket.AF_UNSPEC, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                self.sock = socket.socket(af, socktype, proto)
            except socket.error, msg:
                self.sock = None
                continue
            try:
                self.sock.connect(sa)
                self.fd = self.sock.fileno()
            except socket.error, msg:
                self.sock.close()
                self.sock = None
                continue
            break
        if self.sock is None:
            print 'could not open socket'

    def readFrame(self):
        self.smessage.length = common.rows * common.cols * 4
        #read frame
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockFrame = 0
        else:
            self.flagSockFrame = 1
            self.sock.settimeout(30)
            self.sock.send('RD')
            self.sock.send(struct.pack('L', self.smessage.length))
            print "sent data"
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            common.myArray = na.fromstring(data, na.Float32, (common.rows, common.cols))
            print "saved data to myArray"

    def readPS(self):
        self.smessage.length = (common.rows/2) * (1+common.cols/4) * 4
        #read power spectrum
        self.initSocket()
        if self.sock == None:
            print "socket ps failed to create"
            self.flagSockPS = 0
        else:
            self.flagSockPS = 1
            self.sock.settimeout(30)
            self.sock.send('PS')
            self.sock.send(struct.pack('L', self.smessage.length))
            print "sent data"
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            psArray = na.fromstring(data, na.Float32, (common.rows/2 , 1+common.cols/4))
            r = common.rows
            c = common.cols
            common.psArray = na.resize(common.psArray, (common.rows/2, 1+common.cols/2))
            #top left        
            common.psArray[:r/4, :c/4] = flip(psArray[:r/4, :])[:,:c/4]
            #bottom left
            common.psArray[r/4:, :c/4] = flip(psArray[r/4:, :])[:,:c/4]
            tmp2 = common.psArray[:, :c/4].copy()
            common.psArray[0, :c/4] = tmp2[r/2-1, :c/4]
            common.psArray[1:, :c/4] = tmp2[0:r/2-1, :c/4]
            
            #top right
            common.psArray[:r/4, c/4:] = psArray[r/4:, :]
            #bottom right
            common.psArray[r/4:, c/4:] = psArray[:r/4, :]
            #set to zero the central columns
            common.psArray[:, c/4-2:c/4+3] = 0
            print "saved data to psArray"
        
        
    def run(self):
        """ main control loop """
        print "%s starts" % (self.getName(),)
        while not self._stopevent.isSet():
            if common.status1 == 1 or common.status2 == 1:
                self.readFrame()
                self.readPS()
                if (self.flagSockFrame == 1) and (self.flagSockPS == 1):
                    common.dataready1 = 1
                    common.dataready2 = 1
	    self._stopevent.wait(self._sleepperiod)
        print "%s ends" % (self.getName(),)
        

    def join(self, timeout=None):
        """ Stop the thread. """
        self._stopevent.set()
        threading.Thread.join(self, timeout)


def main():
    #create a thread
    sockThread = socketThread()
    # starts the thread
    sockThread.start()   
    gtk.threads_init()
    #starts the gui
    mainWindow.ApplicationMainWindow()
    gtk.main()
    # stops the thread
    sockThread.join()


if __name__ == "__main__":
    main()


#socket.fromfd(self.fd, af, socktype, proto)

## socket.setdefaulttimeout(5)
## try:
##   urllib.urlopen(url).read()
## except IOError, e:
##   # handle timeout
